--    SQL-Plus    
-- SET SERVEROUTPUT ON SIZE 50000
--     ,    TRUNCATE 
CREATE OR REPLACE PROCEDURE TRUNUSER IS
	CURSOR UNAME IS SELECT UPPER(USER) FROM DUAL;
	CURSOR UCONSTRAINTS IS SELECT TABLE_NAME,CONSTRAINT_NAME FROM USER_CONSTRAINTS
				WHERE CONSTRAINT_TYPE='R';
	CURSOR USNAPLOGS IS SELECT MASTER FROM USER_SNAPSHOT_LOGS;
	CURSOR UTABLES IS SELECT TABLE_NAME FROM USER_TABLES;
	CURSOR UFUNCTIONS IS SELECT OBJECT_NAME FROM USER_OBJECTS
				WHERE OBJECT_TYPE='FUNCTION';
	CURSOR UPACKAGES IS SELECT OBJECT_NAME FROM USER_OBJECTS
				WHERE OBJECT_TYPE='PACKAGE';
	CURSOR UPROCEDURES IS SELECT OBJECT_NAME FROM USER_OBJECTS
				WHERE OBJECT_TYPE='PROCEDURE' AND
				      OBJECT_NAME<>'TRUNUSER';
	CURSOR USEQUENCES IS SELECT SEQUENCE_NAME FROM USER_SEQUENCES;

	I NUMBER;
	TBNAME VARCHAR2(30);
	CONNAME VARCHAR2(30);
	S VARCHAR2(30);
	CURS INTEGER;RET INTEGER;
	SQLSTR VARCHAR2(128);
BEGIN
	-- CHECK USER
	OPEN UNAME;
	FETCH UNAME INTO S;
	DBMS_OUTPUT.PUT_LINE('-- TRUNCATE USER "' || S || '"');
	IF S='SYS' THEN
	    RETURN;
	END IF;
	CLOSE UNAME;

	-- DROP ALL FUNCTIONS
	OPEN UFUNCTIONS;
	LOOP
	  FETCH UFUNCTIONS INTO S;
	  EXIT WHEN UFUNCTIONS%NOTFOUND;
	  SQLSTR:='DROP FUNCTION ' || S;
	  DBMS_OUTPUT.PUT_LINE(SQLSTR||';');
  	  CURS:=DBMS_SQL.OPEN_CURSOR;
	  BEGIN
	    DBMS_SQL.PARSE(CURS,SQLSTR,DBMS_SQL.V7);
	    RET:=DBMS_SQL.EXECUTE(CURS);
	  EXCEPTION
	  WHEN OTHERS THEN
	    DBMS_OUTPUT.PUT_LINE('-- ERROR ' || SQLSTR);
	    RET:=0;
	  END;
	  DBMS_SQL.CLOSE_CURSOR(CURS);
	END LOOP;
	CLOSE UFUNCTIONS;

	-- DROP ALL PROCEDURES
	OPEN UPROCEDURES;
	LOOP
	  FETCH UPROCEDURES INTO S;
	  EXIT WHEN UPROCEDURES%NOTFOUND;
	  SQLSTR:='DROP PROCEDURE ' || S;
	  DBMS_OUTPUT.PUT_LINE(SQLSTR||';');
  	  CURS:=DBMS_SQL.OPEN_CURSOR;
	  BEGIN
	    DBMS_SQL.PARSE(CURS,SQLSTR,DBMS_SQL.V7);
	    RET:=DBMS_SQL.EXECUTE(CURS);
	  EXCEPTION
	  WHEN OTHERS THEN
	    DBMS_OUTPUT.PUT_LINE('-- ERROR ' || SQLSTR);
	    RET:=0;
	  END;
	  DBMS_SQL.CLOSE_CURSOR(CURS);
	END LOOP;
	CLOSE UPROCEDURES;

	-- DROP ALL PACKAGES
	OPEN UPACKAGES;
	LOOP
	  FETCH UPACKAGES INTO S;
	  EXIT WHEN UPACKAGES%NOTFOUND;
	  SQLSTR:='DROP PACKAGE ' || S;
	  DBMS_OUTPUT.PUT_LINE(SQLSTR||';');
  	  CURS:=DBMS_SQL.OPEN_CURSOR;
	  BEGIN
	    DBMS_SQL.PARSE(CURS,SQLSTR,DBMS_SQL.V7);
	    RET:=DBMS_SQL.EXECUTE(CURS);
	  EXCEPTION
	  WHEN OTHERS THEN
	    DBMS_OUTPUT.PUT_LINE('-- ERROR ' || SQLSTR);
	    RET:=0;
	  END;
	  DBMS_SQL.CLOSE_CURSOR(CURS);
	END LOOP;
	CLOSE UPACKAGES;

	-- DROP ALL FOREIGN KEYS
	OPEN UCONSTRAINTS;
	LOOP
	  FETCH UCONSTRAINTS INTO TBNAME,CONNAME;
	  EXIT WHEN UCONSTRAINTS%NOTFOUND;
	  SQLSTR:='ALTER TABLE ' || TBNAME || ' DROP CONSTRAINT ' || CONNAME;
	  DBMS_OUTPUT.PUT_LINE(SQLSTR||';');
  	  CURS:=DBMS_SQL.OPEN_CURSOR;
	  BEGIN
	    DBMS_SQL.PARSE(CURS,SQLSTR,DBMS_SQL.V7);
	    RET:=DBMS_SQL.EXECUTE(CURS);
	  EXCEPTION
	  WHEN OTHERS THEN
	    DBMS_OUTPUT.PUT_LINE('-- ERROR ' || SQLSTR);
	    RET:=0;
	  END;
	  DBMS_SQL.CLOSE_CURSOR(CURS);
	END LOOP;
	CLOSE UCONSTRAINTS;

	  -- LOOP ALL SNAPSHOT LOGS
	OPEN USNAPLOGS;
	LOOP
	  FETCH USNAPLOGS INTO TBNAME;
	  EXIT WHEN USNAPLOGS%NOTFOUND;
 	  -- DROP SNAPSHOT LOGS
	  SQLSTR:='DROP SNAPSHOT LOG ON ' || RTRIM(TBNAME);
	  DBMS_OUTPUT.PUT_LINE(SQLSTR);
	  BEGIN	
	    CURS:=DBMS_SQL.OPEN_CURSOR;
	    DBMS_SQL.PARSE(CURS,SQLSTR,DBMS_SQL.V7);
	    RET:=DBMS_SQL.EXECUTE(CURS);
	  EXCEPTION
	  WHEN OTHERS THEN
	    DBMS_OUTPUT.PUT_LINE('-- ERROR DROP SNAPSHOT LOG ' || RTRIM(TBNAME));
          RET:=0;
	  END;
	  DBMS_SQL.CLOSE_CURSOR(CURS);
	END LOOP;  -- ALL SNAPSHOT LOGS
	CLOSE USNAPLOGS;

	  -- LOOP ALL TABLES
	OPEN UTABLES;
	LOOP
	  FETCH UTABLES INTO TBNAME;
	  EXIT WHEN UTABLES%NOTFOUND;
	  IF SUBSTR(TBNAME,1,5)<>'SNAP$' and SUBSTR(TBNAME,1,5)<>'MLOG$' THEN
		-- TRUNCATE TABLE
		SQLSTR:='TRUNCATE TABLE ' || RTRIM(TBNAME) || ' DROP STORAGE';
		DBMS_OUTPUT.PUT_LINE(SQLSTR||';');
		CURS:=DBMS_SQL.OPEN_CURSOR;
		BEGIN
		  DBMS_SQL.PARSE(CURS,SQLSTR,DBMS_SQL.V7);
		  RET:=DBMS_SQL.EXECUTE(CURS);
		  RET:=1;
		EXCEPTION
		WHEN OTHERS THEN
		  DBMS_OUTPUT.PUT_LINE('-- ERROR TRUNCTE ' || RTRIM(TBNAME));
		  RET:=0;
		END;
		DBMS_SQL.CLOSE_CURSOR(CURS);
		-- DROP TABLE
		SQLSTR:='DROP TABLE ' || RTRIM(TBNAME);
		DBMS_OUTPUT.PUT_LINE(SQLSTR);
		BEGIN	
		  CURS:=DBMS_SQL.OPEN_CURSOR;
		  DBMS_SQL.PARSE(CURS,SQLSTR,DBMS_SQL.V7);
		  RET:=DBMS_SQL.EXECUTE(CURS);
		EXCEPTION
		WHEN OTHERS THEN
		  DBMS_OUTPUT.PUT_LINE('-- ERROR DROP' || RTRIM(TBNAME));
	        RET:=0;
		END;
		DBMS_SQL.CLOSE_CURSOR(CURS);
	  END IF;
	END LOOP;  -- ALL TABLES
	CLOSE UTABLES;

	OPEN USEQUENCES;
	LOOP
	  FETCH USEQUENCES INTO S;
	  EXIT WHEN USEQUENCES%NOTFOUND;
	  SQLSTR:='DROP SEQUENCE ' || RTRIM(S);
          	  DBMS_OUTPUT.PUT_LINE(SQLSTR||';');
	  CURS:=DBMS_SQL.OPEN_CURSOR;
          	  BEGIN
		  DBMS_SQL.PARSE(CURS,SQLSTR,DBMS_SQL.V7);
		  RET:=DBMS_SQL.EXECUTE(CURS);
		  RET:=1;
	  EXCEPTION
	  WHEN OTHERS THEN
		  DBMS_OUTPUT.PUT_LINE('-- ERROR DROP SEQUENCE ' || RTRIM(S));
		  RET:=0;
	  END;
	  DBMS_SQL.CLOSE_CURSOR(CURS);
	END LOOP; -- ALL SEQUENCES
	CLOSE USEQUENCES;

EXCEPTION
	WHEN OTHERS THEN
		IF DBMS_SQL.IS_OPEN(CURS) THEN
			DBMS_SQL.CLOSE_CURSOR(CURS);
		END IF;
		RAISE;
END;
/
